<template>
  <!-- 
    普通查询表格
    v 1.2
    2021-04-30
    Lufthafen
  -->
  <container>
    <br />
    <a-card :bordered="false">
      <yo-table
        :columns="columns"
        :load-data="loadData"
        @query="onQuery"
        @resetQuery="onResetQuery"
        ref="table"
      >
        <Auth auth="sysConfig:page" slot="query">
          <!-- 此处添加查询表单控件 -->
          <!-- ... -->
          <a-form-model-item label="参数名称">
            <a-input placeholder="请输入参数名称" v-model="query.name" />
          </a-form-model-item>
          <a-form-model-item label="唯一编码">
            <a-input placeholder="请输入唯一编码" v-model="query.code" />
          </a-form-model-item>
        </Auth>
        <Auth auth="sysConfig:add" slot="operator">
          <a-button @click="onOpen('add-form')" icon="plus">新增配置</a-button>
        </Auth>
        <!-- 格式化字段内容 -->
        <!-- ... -->
        <!-- 添加操作控件 -->
        <span slot="action" slot-scope="text, record">
          <yo-table-actions>
            <Auth auth="sysConfig:edit">
              <a @click="onOpen('edit-form', record)">编辑</a>
            </Auth>
            <Auth auth="sysConfig:delete">
              <a-popconfirm @confirm="onDelete(record)" placement="topRight" title="是否确认删除">
                <a>删除</a>
              </a-popconfirm>
            </Auth>
            <!-- 可在此处添加其他操作控件 -->
            <!-- ... -->
          </yo-table-actions>
        </span>
      </yo-table>
    </a-card>

    <!-- 新增表单 -->
    <yo-modal-form :action="$api[api.add]" :title="'新增' + name" @ok="onReloadData" ref="add-form">
      <form-body />
    </yo-modal-form>

    <!-- 编辑表单 -->
    <yo-modal-form :action="$api[api.edit]" :title="'编辑' + name" @ok="onReloadData" ref="edit-form">
      <form-body />
    </yo-modal-form>
  </container>
</template>
<script>
import FormBody from './form';

/* 在此管理整个页面需要的接口名称 */
const api = {
  page: 'sysConfigPage',
  add: 'sysConfigAdd',
  edit: 'sysConfigEdit',
  delete: 'sysConfigDelete',
  /* ... */
};

export default {
  components: {
    FormBody,
  },
  data() {
    return {
      api,

      name: '配置',

      /* 查询条件 */
      query: {},

      /* 表格字段 */
      columns: [
        {
          title: '参数名称',
          dataIndex: 'name',
          sorter: true,
        },
        {
          title: '唯一编码',
          dataIndex: 'code',
          sorter: true,
        },
        {
          title: '参数值',
          dataIndex: 'value',
          sorter: true,
        },
        {
          title: '所属分类',
          dataIndex: 'groupCode',
          sorter: true,
        },
        {
          title: '备注',
          dataIndex: 'remark',
          sorter: true,
        },
      ],

      /* 字典编码储存格式 */
      codes: {
        code1: [],
        code2: [],
      },
    };
  },
  created() {
    /** 按需加载字典编码 */
    this.onLoadCodes();

    /** 根据权限添加操作列 */
    const flag = this.$auth({
      sysConfig: [['edit'], ['delete']],
    });
    if (flag) {
      this.columns.push({
        title: '操作',
        width: '150px',
        dataIndex: 'action',
        scopedSlots: { customRender: 'action' },
      });
    }
  },
  methods: {
    /**
     * 必要的方法
     * 传给yo-table以示意数据接口及其参数和返回的数据结构
     */
    loadData(params) {
      return this.$api[api.page]({
        ...params,
        ...this.query,
      }).then((res) => {
        return res.data;
      });
    },

    /**
     * 有查询功能时的必要方法
     * 加载数据时初始化分页信息
     */
    onQuery() {
      this.$refs.table.onReloadData(true);
    },

    /**
     * 有查询功能时的必要方法
     * 重置查询条件
     */
    onResetQuery() {
      /** 在这里重置查询条件时,可对特殊的字段做保留处理 */
      this.query = {};
      this.onQuery();
    },

    /**
     * 必要方法
     * 重新列表数据
     */
    onReloadData() {
      this.$refs.table.onReloadData();
    },

    /**
     * 必要方法
     * 加载字典数据
     * 如果不需要获取相应的字典数据,此方法内容可空
     */
    onLoadCodes() {},

    /**
     * 必要方法
     * 绑定数据字典值
     */
    bindCodeValue(code, name) {
      const c = this.codes[name].find((p) => p.code == code);
      if (c) {
        return c.value;
      }
      return null;
    },

    /**
     * 必要方法
     * 从列表页调用窗口的打开方法
     */
    onOpen(formName, record) {
      this.$refs[formName].onOpen({
        record,
        /* 按需添加其他参数 */
        /* ... */
      });
    },

    /**
     * 必要方法
     * 可以用做一系列操作的公共回调,此方法中会重新加载当前列表
     */
    onResult(success, successMessage) {
      if (success) {
        this.$message.success(successMessage);
        this.onReloadData();
      }
    },

    /**
     * 必要方法
     * 删除时调用
     */
    onDelete(record) {
      this.$refs.table.onLoading();
      this.$api[api.delete](record)
        .then(({ success }) => {
          this.onResult(success, '删除成功');
        })
        .finally(() => {
          this.$refs.table.onLoaded();
        });
    },
  },
};
</script>